include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "leibniz.ma".
include "nat.ma".
axiom bigop : \forall H : Type[0] . nat -> (nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H.
axiom bigop_body : \forall H : Type[0] . nat -> (nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H.
axiom axiom_bigop_body_S : \forall H. \forall (n:nat). (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)).
definition eq_bigop_body_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)) := \lambda H : Type[0]. \lambda n : nat. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) ((S)  n))) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n))) (((axiom_bigop_body_S) (H)) (n)).
definition sym_eq_bigop_body_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)) ((bigop_body) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) ((S)  n))) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n))) (((eq_bigop_body_S) (H)) (n)).
